public class Personne
{
   private static final String
      NOM_DFAUT = "Blo",
      PRNOM_DFAUT = "Joe";
   private static final boolean
      SEXE_MASCULIN = false,
      SEXE_FMININ  = true,
      SEXE_DFAUT = SEXE_FMININ;
   private static final short
      GE_MIN = 0,
      GE_MAX = 130, // arbitraire
      GE_MAJORIT = 18,
      GE_DFAUT = GE_MAJORIT; // arbitraire

   public Personne ()
   {
      SetNomBrut (NOM_DFAUT);
      SetPrnomBrut (PRNOM_DFAUT);
      SetSexe (SEXE_DFAUT);
      SetgeBrut (GE_DFAUT);
   }
   public Personne (final String Nom, final String Prnom,
                    final boolean Sexe)
      throws Exception
   {
      SetNom (Nom);
      SetPrnom (Prnom);
      SetSexe (Sexe);
      SetgeBrut (GE_DFAUT);
   }
   public Personne (final String Nom, final String Prnom,
                    final boolean Sexe, final short ge)
      throws Exception
   {
      SetNom (Nom);
      SetPrnom (Prnom);
      SetSexe (Sexe);
      Setge (ge);
   }
   public Personne (Personne Original)
   {
      SetNomBrut (Original.GetNom ());
      SetPrnomBrut (Original.GetPrnom ());
      SetSexe (Original.GetSexe ());
      SetgeBrut (Original.Getge ());
   }
   // Accesseurs
   public String GetNom ()
   {
      return m_Nom;
   }
   public String GetPrnom ()
   {
      return m_Prnom;
   }
   public boolean GetSexe ()
   {
      return m_Sexe;
   }
   public short Getge ()
   {
      return m_ge;
   }
   // Manipulateurs
   public void SetNom (final String Nom)
      throws Exception
   {
      if (Nom == null)
         throw new Exception ("Nom nul (interdit)");
      SetNomBrut (Nom);
   }
   private void SetNomBrut (final String Nom)
   {
      m_Nom = Nom;
   }

   public void SetPrnom (final String Prnom)
      throws Exception
   {
      if (Prnom == null)
         throw new Exception ("Prnom nul (interdit)");
      SetPrnomBrut (Prnom);
   }
   private void SetPrnomBrut (final String Prnom)
   {
      m_Prnom = Prnom;
   }

   public void SetSexe (final boolean Sexe)
   {
      m_Sexe = Sexe;
   }
   public void Setge (final short ge)
      throws Exception
   {
      if (ge < GE_MIN || ge > GE_MAX)
         throw new Exception ("ge hors des bornes tolres");
      SetgeBrut (ge);
   }
   private void SetgeBrut (final short ge)
   {
      m_ge = ge;
   }

   // Oprateurs
   public Personne copy (Personne p)
   {
      SetNomBrut (p.GetNom ());
      SetPrnomBrut (p.GetPrnom ());
      SetSexe (p.GetSexe ());
      SetgeBrut (p.Getge ());
      return this;
   }
   public boolean equals (Personne p)
   {
      return p != null &&
             GetNom ().equals (p.GetNom ()) &&
             GetPrnom ().equals (p.GetPrnom ()) &&
             GetSexe () == p.GetSexe () &&
             Getge () == p.Getge ();
   }
   public String QuiSuisJe ()
   {
      return "Mon nom est " + GetNom () +
             " et j'ai " + Getge () + " ans";
   }


   private String m_Prnom, m_Nom;
   private boolean m_Sexe;
   private short m_ge;
}
