// Rectangle.java
public class Rectangle extends Forme
{
   public int GetHauteur ()
   {
      return m_Hauteur;
   }
   public int GetLargeur ()
   {
      return m_Largeur;
   }
   public void SetHauteur (final int Hauteur)
      throws Exception
   {
      if (!EstHauteurValide (Hauteur))
         throw new Exception ("Hauteur invalide");
      SetHauteurBrut (Hauteur);
   }
   private void SetHauteurBrut (final int Hauteur)
   {
      m_Hauteur = Hauteur;
   }
   public void SetLargeur (final int Largeur)
      throws Exception
   {
      if (!EstLargeurValide (Largeur))
         throw new Exception ("Largeur invalide");
      SetLargeurBrut (Largeur);
   }
   private void SetLargeurBrut (final int Largeur)
   {
      m_Largeur = Largeur;
   }
   private int GetAire ()
   {
      return GetLargeur () * GetHauteur ();
   }
   private int GetPrimtre ()
   {
      return (GetLargeur () + GetHauteur ()) * 2;
   }
   private static boolean EstLargeurValide (final int Largeur)
   {
      return Largeur >= GetLargeurMin () && Largeur <= GetLargeurMax ();
   }
   private static boolean EstHauteurValide (final int Hauteur)
   {
      return Hauteur >= GetHauteurMin () && Hauteur <= GetHauteurMax ();
   }

   public static int GetHauteurMin ()
   {
      return HAUTEUR_MIN;
   }
   public static int GetHauteurMax ()
   {
      return HAUTEUR_MAX;
   }
   public static int GetLargeurMin ()
   {
      return LARGEUR_MIN;
   }
   public static int GetLargeurMax ()
   {
      return LARGEUR_MAX;
   }

   private static final int
      HAUTEUR_MIN = 1,
      HAUTEUR_MAX = 20;
   private static final int
      LARGEUR_MIN = 1,
      LARGEUR_MAX = 50;
   private static final int
      HAUTEUR_DFAUT = HAUTEUR_MIN,
      LARGEUR_DFAUT = LARGEUR_MIN;
   private int m_Hauteur,
               m_Largeur;
   public void Dessiner ()
   {
      for (int i = 0; i < GetHauteur (); i++)
      {
         for (int j = 0; j < GetLargeur (); j++)
         {
            System.out.print ("*");
         }
         System.out.println ();
      }
   }
   //
   // Constructeurs
   //
   Rectangle ()
   {
      super ();
      SetHauteurBrut (HAUTEUR_DFAUT);
      SetLargeurBrut (LARGEUR_DFAUT);
   }
   //
   // Si une exception est lance dans la mthode, on
   // la laisse filtrer vers l'appelant
   //
   Rectangle (final int Hauteur, final int Largeur)
      throws Exception
   {
      super ();
      SetHauteur (Hauteur);
      SetLargeur (Largeur);
   }
   Rectangle (final Rectangle r)
   {
      super (r);
      SetHauteurBrut (r.GetHauteur ());
      SetLargeurBrut (r.GetLargeur ());
   }
   //
   // Comparaisons possibles
   //
   private boolean gauxAttributParAttribut (final Rectangle r)
   {
      return super.equals (r) &&
             GetHauteur () == r.GetHauteur () &&
             GetLargeur () == r.GetLargeur ();
   }
   private boolean gauxContour (final Rectangle r)
   {
      return super.equals (r) &&
             GetPrimtre () == r.GetPrimtre();
   }
   private boolean gauxSurface (final Rectangle r)
   {
      return super.equals (r) &&
             GetAire () == r.GetAire();
   }
   //
   // Comparaison choisie (choix politique)
   //
   public boolean equals (final Rectangle r)
   {
      return gauxAttributParAttribut (r);
   }
   //
   // Copie de contenu
   //
   public void copy (final Rectangle r)
   {
      super.copy (r);
      SetHauteurBrut (r.GetHauteur());
      SetLargeurBrut (r.GetLargeur());
   }
}
